Index: applications/bdmtoolbox/tutorial/exp/arx_ui/kst.kst
===================================================================
--- applications/bdmtoolbox/tutorial/exp/arx_ui/kst.kst (revision 273)
+++ applications/bdmtoolbox/tutorial/exp/arx_ui/kst.kst (revision 412)
@@ -9,5 +9,5 @@
   <kstfile>
     <tag>DS-arx_ui</tag>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <type>Directory of Binary Files</type>
   </kstfile>
@@ -115,5 +115,5 @@
     <tag>DS-arx_ui/INDEX</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>INDEX</field>
     <start>-1</start>
@@ -123,5 +123,5 @@
     <tag>DS-arx_ui/t_th_0</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>t_th_0</field>
     <start>-1</start>
@@ -131,5 +131,5 @@
     <tag>DS-arx_ui/t_th_2</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>t_th_2</field>
     <start>-1</start>
@@ -139,5 +139,5 @@
     <tag>DS-arx_ui/t_th_4</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>t_th_4</field>
     <start>-1</start>
@@ -147,5 +147,5 @@
     <tag>DS-arx_ui/t_th_6</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>t_th_6</field>
     <start>-1</start>
@@ -155,5 +155,5 @@
     <tag>DS-arx_ui/r_R_0</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>r_R_0</field>
     <start>-1</start>
@@ -163,5 +163,5 @@
     <tag>DS-arx_ui/est_theta_0</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>est_theta_0</field>
     <start>-1</start>
@@ -171,5 +171,5 @@
     <tag>DS-arx_ui/est_theta_1</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>est_theta_1</field>
     <start>-1</start>
@@ -179,5 +179,5 @@
     <tag>DS-arx_ui/est_theta_2</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>est_theta_2</field>
     <start>-1</start>
@@ -187,5 +187,5 @@
     <tag>DS-arx_ui/est_theta_3</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>est_theta_3</field>
     <start>-1</start>
@@ -195,5 +195,5 @@
     <tag>DS-arx_ui/est_r</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>est_r</field>
     <start>-1</start>
@@ -203,5 +203,5 @@
     <tag>DS-arx_ui/lb_theta_0</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>lb_theta_0</field>
     <start>-1</start>
@@ -211,5 +211,5 @@
     <tag>DS-arx_ui/lb_theta_1</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>lb_theta_1</field>
     <start>-1</start>
@@ -219,5 +219,5 @@
     <tag>DS-arx_ui/lb_theta_2</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>lb_theta_2</field>
     <start>-1</start>
@@ -227,5 +227,5 @@
     <tag>DS-arx_ui/lb_theta_3</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>lb_theta_3</field>
     <start>-1</start>
@@ -235,5 +235,5 @@
     <tag>DS-arx_ui/lb_r</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>lb_r</field>
     <start>-1</start>
@@ -243,5 +243,5 @@
     <tag>DS-arx_ui/ub_theta_0</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>ub_theta_0</field>
     <start>-1</start>
@@ -251,5 +251,5 @@
     <tag>DS-arx_ui/ub_theta_1</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>ub_theta_1</field>
     <start>-1</start>
@@ -259,5 +259,5 @@
     <tag>DS-arx_ui/ub_theta_2</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>ub_theta_2</field>
     <start>-1</start>
@@ -267,5 +267,5 @@
     <tag>DS-arx_ui/ub_theta_3</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>ub_theta_3</field>
     <start>-1</start>
@@ -275,5 +275,5 @@
     <tag>DS-arx_ui/ub_r</tag>
     <provider>DS-arx_ui</provider>
-    <filename>/home/smidl/work/git/mixpp/library/tutorial/exp/arx_ui/</filename>
+    <filename>/home/smidl/work/git/mixpp/applications/bdmtoolbox/tutorial/exp/arx_ui/</filename>
     <field>ub_r</field>
     <start>-1</start>