Index: library/tests/epdf_test.cpp
===================================================================
--- library/tests/epdf_test.cpp (revision 457)
+++ library/tests/epdf_test.cpp (revision 457)
@@ -0,0 +1,31 @@
+#define BDMLIB // not an ideal way to prevent double registration of UI factories...
+#include "base/user_info.h"
+#include "stat/exp_family.h"
+#include "epdf_harness.h"
+#include "UnitTest++.h"
+
+using namespace bdm;
+
+template<>
+const ParticularUI<egamma> &ParticularUI<egamma>::factory(
+    ParticularUI<egamma>("egamma"));
+
+template<>
+const ParticularUI<enorm<ldmat> > &ParticularUI<enorm<ldmat> >::factory(
+    ParticularUI<enorm<ldmat> >("enorm<ldmat>"));
+
+template<>
+const ParticularUI<enorm<fsqmat> > &ParticularUI<enorm<fsqmat> >::factory(
+    ParticularUI<enorm<fsqmat> >("enorm<fsqmat>"));
+
+ template<>
+const ParticularUI<enorm<chmat> > &ParticularUI<enorm<chmat> >::factory(
+    ParticularUI<enorm<chmat> >("enorm<chmat>"));
+
+TEST(test_egamma) {
+    epdf_harness::test_config("egamma.cfg");
+}
+
+TEST(test_enorm) {
+    epdf_harness::test_config("enorm.cfg");
+}
Index: library/tests/mpdf_test.cpp
===================================================================
--- library/tests/mpdf_test.cpp (revision 457)
+++ library/tests/mpdf_test.cpp (revision 457)
@@ -0,0 +1,18 @@
+#define BDMLIB // not an ideal way to prevent double registration of UI factories...
+#include "base/bdmbase.h"
+#include "base/user_info.h"
+#include "stat/exp_family.h"
+#include "itpp_ext.h"
+#include "mpdf_harness.h"
+#include "mat_checks.h"
+#include "UnitTest++.h"
+
+using namespace bdm;
+
+template<>
+const ParticularUI<mgamma> &ParticularUI<mgamma>::factory(
+    ParticularUI<mgamma>("mgamma"));
+
+TEST(test_mgamma) {
+    mpdf_harness::test_config("mgamma.cfg");
+}
Index: library/tests/CMakeLists.txt
===================================================================
--- library/tests/CMakeLists.txt (revision 453)
+++ library/tests/CMakeLists.txt (revision 457)
@@ -33,5 +33,5 @@
 
 # using UnitTest++
-add_executable(testsuite datalink_test.cpp egamma_test.cpp egiw_test.cpp enorm_test.cpp loggers_test.cpp mepdf_test.cpp mgamma_test.cpp rv_test.cpp square_mat_test.cpp testsuite.cpp test_user_info.cpp test_shared_ptr.cpp)
+add_executable(testsuite datalink_test.cpp egiw_test.cpp epdf_test.cpp loggers_test.cpp mepdf_test.cpp mpdf_test.cpp rv_test.cpp square_mat_test.cpp testsuite.cpp test_user_info.cpp test_shared_ptr.cpp)
 target_link_libraries(testsuite bdm itpp testutil unittest)
 
Index: library/tests/mgamma_test.cpp
===================================================================
--- library/tests/mgamma_test.cpp (revision 456)
+++  (revision )
@@ -1,18 +1,0 @@
-#define BDMLIB // not an ideal way to prevent double registration of UI factories...
-#include "base/bdmbase.h"
-#include "base/user_info.h"
-#include "stat/exp_family.h"
-#include "itpp_ext.h"
-#include "mpdf_harness.h"
-#include "mat_checks.h"
-#include "UnitTest++.h"
-
-using namespace bdm;
-
-template<>
-const ParticularUI<mgamma> &ParticularUI<mgamma>::factory(
-    ParticularUI<mgamma>("mgamma"));
-
-TEST(test_mgamma) {
-    mpdf_harness::test_config("mgamma.cfg");
-}
Index: library/tests/enorm_test.cpp
===================================================================
--- library/tests/enorm_test.cpp (revision 456)
+++  (revision )
@@ -1,24 +1,0 @@
-#define BDMLIB // not an ideal way to prevent double registration of UI factories...
-#include "stat/exp_family.h"
-#include "epdf_harness.h"
-#include "UnitTest++.h"
-
-using namespace bdm;
-
-const double epsilon = 0.00001;
-
-template<>
-const ParticularUI<enorm<ldmat> > &ParticularUI<enorm<ldmat> >::factory(
-    ParticularUI<enorm<ldmat> >("enorm<ldmat>"));
-
-template<>
-const ParticularUI<enorm<fsqmat> > &ParticularUI<enorm<fsqmat> >::factory(
-    ParticularUI<enorm<fsqmat> >("enorm<fsqmat>"));
-
- template<>
-const ParticularUI<enorm<chmat> > &ParticularUI<enorm<chmat> >::factory(
-    ParticularUI<enorm<chmat> >("enorm<chmat>"));
-
-TEST(test_enorm) {
-    epdf_harness::test_config("enorm.cfg");
-}
Index: library/tests/egamma_test.cpp
===================================================================
--- library/tests/egamma_test.cpp (revision 456)
+++  (revision )
@@ -1,15 +1,0 @@
-#define BDMLIB // not an ideal way to prevent double registration of UI factories...
-#include "base/user_info.h"
-#include "stat/exp_family.h"
-#include "epdf_harness.h"
-#include "UnitTest++.h"
-
-using namespace bdm;
-
-template<>
-const ParticularUI<egamma> &ParticularUI<egamma>::factory(
-    ParticularUI<egamma>("egamma"));
-
-TEST(test_egamma) {
-    epdf_harness::test_config("egamma.cfg");
-}