Index: library/doc/html/classbdm_1_1mmix.html
===================================================================
--- library/doc/html/classbdm_1_1mmix.html (revision 401)
+++ library/doc/html/classbdm_1_1mmix.html (revision 472)
@@ -5,5 +5,5 @@
 <link href="doxygen.css" rel="stylesheet" type="text/css">
 </head><body>
-<!-- Generated by Doxygen 1.5.8 -->
+<!-- Generated by Doxygen 1.5.9 -->
 <script type="text/javascript">
 <!--
@@ -52,5 +52,4 @@
       <li><a href="main.html"><span>Main&nbsp;Page</span></a></li>
       <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
-      <li><a href="modules.html"><span>Modules</span></a></li>
       <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
       <li><a href="files.html"><span>Files</span></a></li>
@@ -72,5 +71,5 @@
 <a href="#_details">More...</a>
 <p>
-<code>#include &lt;<a class="el" href="emix_8h-source.html">emix.h</a>&gt;</code>
+<code>#include &lt;<a class="el" href="emix_8h_source.html">emix.h</a>&gt;</code>
 <p>
 
@@ -106,20 +105,20 @@
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">This method TODO. <br></td></tr>
 <tr><td colspan="2"><div class="groupHeader">Matematical operations</div></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#f0c1db6fcbb3aae2dd6123884457a367">samplecond</a> (const vec &amp;cond)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a sample from the density conditioned on <code>cond</code>, <img class="formulaInl" alt="$x \sim epdf(rv|cond)$" src="form_11.png">.  <a href="#f0c1db6fcbb3aae2dd6123884457a367"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual mat&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#afe4185b26baeb03688202e254d3b005">samplecond_m</a> (const vec &amp;cond, int N)</td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns.  <a href="#afe4185b26baeb03688202e254d3b005"></a><br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="6336a8a72462e2a56a3989a220f18b1b"></a><!-- doxytag: member="bdm::mmix::evallogcond" ref="6336a8a72462e2a56a3989a220f18b1b" args="(const vec &amp;dt, const vec &amp;cond)" -->
-virtual double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#6336a8a72462e2a56a3989a220f18b1b">evallogcond</a> (const vec &amp;dt, const vec &amp;cond)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#b024f2e636e5507c755de4a6df1f1e99">samplecond</a> (const vec &amp;cond)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns a sample from the density conditioned on <code>cond</code>, <img class="formulaInl" alt="$x \sim epdf(rv|cond)$" src="form_11.png">.  <a href="#b024f2e636e5507c755de4a6df1f1e99"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top">virtual mat&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#6e497d501331057309d2fddf63259d1a">samplecond_m</a> (const vec &amp;cond, int N)</td></tr>
+
+<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Returns.  <a href="#6e497d501331057309d2fddf63259d1a"></a><br></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="cfcbb897bf42015a7979b17d891fd9b5"></a><!-- doxytag: member="bdm::mmix::evallogcond" ref="cfcbb897bf42015a7979b17d891fd9b5" args="(const vec &amp;dt, const vec &amp;cond)" -->
+virtual double&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#cfcbb897bf42015a7979b17d891fd9b5">evallogcond</a> (const vec &amp;dt, const vec &amp;cond)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Shortcut for conditioning and evaluation of the internal <a class="el" href="classbdm_1_1epdf.html" title="Probability density function with numerical statistics, e.g. posterior density.">epdf</a>. In some cases, this operation can be implemented efficiently. <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="0b0ed1ed663071bb7cf4a1349eb94fcb"></a><!-- doxytag: member="bdm::mmix::evallogcond_m" ref="0b0ed1ed663071bb7cf4a1349eb94fcb" args="(const mat &amp;Dt, const vec &amp;cond)" -->
-virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#0b0ed1ed663071bb7cf4a1349eb94fcb">evallogcond_m</a> (const mat &amp;Dt, const vec &amp;cond)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="f97c61ecfb1f44ef6f08dee7bc15eab3"></a><!-- doxytag: member="bdm::mmix::evallogcond_m" ref="f97c61ecfb1f44ef6f08dee7bc15eab3" args="(const mat &amp;Dt, const vec &amp;cond)" -->
+virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#f97c61ecfb1f44ef6f08dee7bc15eab3">evallogcond_m</a> (const mat &amp;Dt, const vec &amp;cond)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Matrix version of evallogcond. <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="2a0d03756f59924fd038980ee60bd904"></a><!-- doxytag: member="bdm::mmix::evallogcond_m" ref="2a0d03756f59924fd038980ee60bd904" args="(const Array&lt; vec &gt; &amp;Dt, const vec &amp;cond)" -->
-virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#2a0d03756f59924fd038980ee60bd904">evallogcond_m</a> (const Array&lt; vec &gt; &amp;Dt, const vec &amp;cond)</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="2d7d3c23e3273e97c12c396dcc06b606"></a><!-- doxytag: member="bdm::mmix::evallogcond_m" ref="2d7d3c23e3273e97c12c396dcc06b606" args="(const Array&lt; vec &gt; &amp;Dt, const vec &amp;cond)" -->
+virtual vec&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#2d7d3c23e3273e97c12c396dcc06b606">evallogcond_m</a> (const Array&lt; vec &gt; &amp;Dt, const vec &amp;cond)</td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Array&lt;vec&gt; version of evallogcond. <br></td></tr>
@@ -137,9 +136,9 @@
 int&nbsp;</td><td class="memItemRight" valign="bottom"><b>dimensionc</b> ()</td></tr>
 
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="1892fe3933488942253679f068e9e7f6"></a><!-- doxytag: member="bdm::mmix::_epdf" ref="1892fe3933488942253679f068e9e7f6" args="()" -->
-<a class="el" href="classbdm_1_1epdf.html">epdf</a> &amp;&nbsp;</td><td class="memItemRight" valign="bottom"><b>_epdf</b> ()</td></tr>
-
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="05e843fd11c410a99dad2b88c55aca80"></a><!-- doxytag: member="bdm::mmix::_e" ref="05e843fd11c410a99dad2b88c55aca80" args="()" -->
-<a class="el" href="classbdm_1_1epdf.html">epdf</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><b>_e</b> ()</td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="4c2d7d3d1d75cca84993e77867d1ffbe"></a><!-- doxytag: member="bdm::mmix::e" ref="4c2d7d3d1d75cca84993e77867d1ffbe" args="()" -->
+<a class="el" href="classbdm_1_1epdf.html">epdf</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><b>e</b> ()</td></tr>
+
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="a4ba1b384c9c1cb18422a8ba32a5d019"></a><!-- doxytag: member="bdm::mmix::set_ep" ref="a4ba1b384c9c1cb18422a8ba32a5d019" args="(shared_ptr&lt; epdf &gt; ep)" -->
+void&nbsp;</td><td class="memItemRight" valign="bottom"><b>set_ep</b> (<a class="el" href="classbdm_1_1shared__ptr.html">shared_ptr</a>&lt; <a class="el" href="classbdm_1_1epdf.html">epdf</a> &gt; ep)</td></tr>
 
 <tr><td colspan="2"><div class="groupHeader">Connection to other objects</div></td></tr>
@@ -158,6 +157,6 @@
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Component (epdfs). <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="0c4dd6ca6556ddd8ae3c5f3257c04b60"></a><!-- doxytag: member="bdm::mmix::Epdf" ref="0c4dd6ca6556ddd8ae3c5f3257c04b60" args="" -->
-<a class="el" href="classbdm_1_1emix.html">emix</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mmix.html#0c4dd6ca6556ddd8ae3c5f3257c04b60">Epdf</a></td></tr>
+<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="e83f03cf2c9383651881c2f235a27365"></a><!-- doxytag: member="bdm::mmix::iepdf" ref="e83f03cf2c9383651881c2f235a27365" args="" -->
+<a class="el" href="classbdm_1_1shared__ptr.html">shared_ptr</a>&lt; <a class="el" href="classbdm_1_1emix.html">emix</a> &gt;&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mmix.html#e83f03cf2c9383651881c2f235a27365">iepdf</a></td></tr>
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Internal <a class="el" href="classbdm_1_1epdf.html" title="Probability density function with numerical statistics, e.g. posterior density.">epdf</a>. <br></td></tr>
@@ -170,8 +169,4 @@
 
 <tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">random variable in condition <br></td></tr>
-<tr><td class="memItemLeft" nowrap align="right" valign="top"><a class="anchor" name="5eea43c56d38e4441bfb30270db949c0"></a><!-- doxytag: member="bdm::mmix::ep" ref="5eea43c56d38e4441bfb30270db949c0" args="" -->
-<a class="el" href="classbdm_1_1epdf.html">epdf</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="classbdm_1_1mpdf.html#5eea43c56d38e4441bfb30270db949c0">ep</a></td></tr>
-
-<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">pointer to internal <a class="el" href="classbdm_1_1epdf.html" title="Probability density function with numerical statistics, e.g. posterior density.">epdf</a> <br></td></tr>
 </table>
 <hr><a name="_details"></a><h2>Detailed Description</h2>
@@ -189,5 +184,5 @@
           <td class="paramname"> <em>set</em>          </td>
           <td>&nbsp;)&nbsp;</td>
-          <td><code> [inline, virtual, inherited]</code></td>
+          <td><code> [virtual, inherited]</code></td>
         </tr>
       </table>
@@ -203,19 +198,19 @@
 <p>Reimplemented from <a class="el" href="classbdm_1_1root.html#0551e3121091c5199bf4413b50522176">bdm::root</a>.</p>
 
-<p>Reimplemented in <a class="el" href="classbdm_1_1mepdf.html#27ef18a3e3b1b5de02739d1324bf25fb">bdm::mepdf</a>, <a class="el" href="classbdm_1_1mprod.html#bfa7478f8df1de6d8cd4c349db512831">bdm::mprod</a>, <a class="el" href="classbdm_1_1mgnorm.html#d717dacc6a9eb967f8410994dc6dc6f9">bdm::mgnorm&lt; sq_T &gt;</a>, <a class="el" href="classbdm_1_1mgamma.html#da2af0f327e5452bee71d1bf97452ae4">bdm::mgamma</a>, <a class="el" href="classbdm_1_1migamma__ref.html#9e7e0f7d2aa9ecca8ec1af8cbcb5ef1d">bdm::migamma_ref</a>, and <a class="el" href="classbdm_1_1mlognorm.html#49e45ea13a869da607ef9be7a229128a">bdm::mlognorm</a>.</p>
+<p>Reimplemented in <a class="el" href="classbdm_1_1mepdf.html#27ef18a3e3b1b5de02739d1324bf25fb">bdm::mepdf</a>, <a class="el" href="classbdm_1_1mprod.html#bfa7478f8df1de6d8cd4c349db512831">bdm::mprod</a>, <a class="el" href="classbdm_1_1mlnorm.html#8582928555c309a2865f385dd0441fd1">bdm::mlnorm&lt; sq_T &gt;</a>, <a class="el" href="classbdm_1_1mgnorm.html#d717dacc6a9eb967f8410994dc6dc6f9">bdm::mgnorm&lt; sq_T &gt;</a>, <a class="el" href="classbdm_1_1mgamma.html#da2af0f327e5452bee71d1bf97452ae4">bdm::mgamma</a>, <a class="el" href="classbdm_1_1migamma__ref.html#9e7e0f7d2aa9ecca8ec1af8cbcb5ef1d">bdm::migamma_ref</a>, <a class="el" href="classbdm_1_1mlognorm.html#49e45ea13a869da607ef9be7a229128a">bdm::mlognorm</a>, <a class="el" href="classbdm_1_1mlnorm.html#8582928555c309a2865f385dd0441fd1">bdm::mlnorm&lt; chmat &gt;</a>, and <a class="el" href="classbdm_1_1mlnorm.html#8582928555c309a2865f385dd0441fd1">bdm::mlnorm&lt; ldmat &gt;</a>.</p>
 
 </div>
 </div><p>
-<a class="anchor" name="f0c1db6fcbb3aae2dd6123884457a367"></a><!-- doxytag: member="bdm::mmix::samplecond" ref="f0c1db6fcbb3aae2dd6123884457a367" args="(const vec &amp;cond)" -->
+<a class="anchor" name="b024f2e636e5507c755de4a6df1f1e99"></a><!-- doxytag: member="bdm::mmix::samplecond" ref="b024f2e636e5507c755de4a6df1f1e99" args="(const vec &amp;cond)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">virtual vec bdm::mpdf::samplecond           </td>
+          <td class="memname">vec bdm::mpdf::samplecond           </td>
           <td>(</td>
           <td class="paramtype">const vec &amp;&nbsp;</td>
           <td class="paramname"> <em>cond</em>          </td>
           <td>&nbsp;)&nbsp;</td>
-          <td><code> [inline, virtual, inherited]</code></td>
+          <td><code> [virtual, inherited]</code></td>
         </tr>
       </table>
@@ -234,16 +229,16 @@
 <p>Reimplemented in <a class="el" href="classbdm_1_1mprod.html#ee715a8013acf9892f6cb489db595555">bdm::mprod</a>.</p>
 
-<p>References <a class="el" href="bdmbase_8h-source.html#l00376">bdm::mpdf::condition()</a>, <a class="el" href="bdmbase_8h-source.html#l00348">bdm::mpdf::ep</a>, and <a class="el" href="bdmbase_8h-source.html#l00263">bdm::epdf::sample()</a>.</p>
-
-<p>Referenced by <a class="el" href="particles_8h-source.html#l00207">bdm::MPF&lt; BM_T &gt;::bayes()</a>, <a class="el" href="particles_8cpp-source.html#l00007">bdm::PF::bayes()</a>, and <a class="el" href="datasources_8cpp-source.html#l00043">bdm::ArxDS::step()</a>.</p>
+<p>References <a class="el" href="bdmbase_8h_source.html#l00376">bdm::mpdf::condition()</a>.</p>
+
+<p>Referenced by <a class="el" href="particles_8h_source.html#l00207">bdm::MPF&lt; BM_T &gt;::bayes()</a>, <a class="el" href="particles_8cpp_source.html#l00007">bdm::PF::bayes()</a>, and <a class="el" href="datasources_8cpp_source.html#l00043">bdm::ArxDS::step()</a>.</p>
 
 </div>
 </div><p>
-<a class="anchor" name="afe4185b26baeb03688202e254d3b005"></a><!-- doxytag: member="bdm::mmix::samplecond_m" ref="afe4185b26baeb03688202e254d3b005" args="(const vec &amp;cond, int N)" -->
+<a class="anchor" name="6e497d501331057309d2fddf63259d1a"></a><!-- doxytag: member="bdm::mmix::samplecond_m" ref="6e497d501331057309d2fddf63259d1a" args="(const vec &amp;cond, int N)" -->
 <div class="memitem">
 <div class="memproto">
       <table class="memname">
         <tr>
-          <td class="memname">virtual mat bdm::mpdf::samplecond_m           </td>
+          <td class="memname">mat bdm::mpdf::samplecond_m           </td>
           <td>(</td>
           <td class="paramtype">const vec &amp;&nbsp;</td>
@@ -259,5 +254,5 @@
           <td></td>
           <td>)</td>
-          <td></td><td></td><td><code> [inline, virtual, inherited]</code></td>
+          <td></td><td></td><td><code> [virtual, inherited]</code></td>
         </tr>
       </table>
@@ -275,14 +270,14 @@
 </dl>
 
-<p>References <a class="el" href="bdmbase_8h-source.html#l00376">bdm::mpdf::condition()</a>, <a class="el" href="bdmbase_8h-source.html#l00318">bdm::epdf::dimension()</a>, <a class="el" href="bdmbase_8h-source.html#l00348">bdm::mpdf::ep</a>, and <a class="el" href="bdmbase_8h-source.html#l00263">bdm::epdf::sample()</a>.</p>
+<p>References <a class="el" href="bdmbase_8h_source.html#l00376">bdm::mpdf::condition()</a>.</p>
 
 </div>
 </div><p>
 <hr>The documentation for this class was generated from the following file:<ul>
-<li><a class="el" href="emix_8h-source.html">emix.h</a></ul>
-</div>
-<hr size="1"><address style="text-align: right;"><small>Generated on Wed Jul 1 13:05:57 2009 for mixpp by&nbsp;
+<li><a class="el" href="emix_8h_source.html">emix.h</a></ul>
+</div>
+<hr size="1"><address style="text-align: right;"><small>Generated on Wed Aug 5 00:07:01 2009 for mixpp by&nbsp;
 <a href="http://www.doxygen.org/index.html">
-<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.8 </small></address>
+<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.9 </small></address>
 </body>
 </html>